function CompetenceTable(id, comp, parent, hide) {
	this.id = id;
	this.comp = comp;
	this.parent = parent;

	if (hide == undefined)
		hide = true;


	//changed!
	this.makeTableAndHeader(hide);
	this.table = $('#' + id);

	
	//this.addHeader(hide);

	var catInd = 0;
	for ( var i = 0; i < comp.categories.length; i++) {
		var cat = comp.categories[i];
		if (hide || cat.visible)
			this.addCategory(cat, catInd++, hide);
	}
	
	//NEW
	this.addLastRow(catInd,hide);
	

	if (hide) {
		this.toggleAll = $('#toggle' + this.id);
		this.toggleAll[0].table = this;
		this.toggleAll.change(function() {
			var checked = this.checked;

			this.table.table.find('input[type="checkbox"]').each(function() {
				this.checked = checked;

			});

			var cp = this.table.comp.categories;
			for ( var i = 0; i < cp.length; i++) {
				cp[i].visible = checked;
			}

		});
	}
}

CompetenceTable.prototype.makeTable = function(hide) {

	var check = !hide ? '' : '<th class="checkRow"></th>';

	var table = '<table id="'
			+ this.id
			+ '" class="competenceTable"> <tr> '
			+ check

			+ ' <th class="headerRow"></th> <th class="ratingRow">++</th> <th class="halfRatingRow"> </th> <th class="ratingRow">+</th> <th class="halfRatingRow"> </th> <th class="ratingRow">o</th> <th class="halfRatingRow"> </th> <th class="ratingRow">-</th> <th class="halfRatingRow"> </th> <th class="ratingRow">--</th> </tr> </table>';
	$('#' + this.parent).append(table);
};

//NEW
CompetenceTable.prototype.addLastRow = function(index, check){
	
	var chb = !check ? '' : '<td class="noBorder"></td>';

	var tr = index % 2 == 1 ? '<tr >' : '<tr class="secondRow">';

	this.table
			.append(tr
					+ chb 
					+ '<td class="lastRow"><a class="subCompHeader">Bewertungsdurchschnitt: </a></td> <td class="lastRow"></td>  <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> <td class="lastRow"> </td> </tr>');

}

CompetenceTable.prototype.makeTableAndHeader = function(check){

	if (check == undefined)
		check = true;

	var cl = this.makeCommaList(this.comp.categories);

	var chb = !check ? '' : '<th class="checkRow noBorder"><input id="toggle' + this.id
			+ '" type="checkbox"></th>';


	var table = '<table id="'
			+ this.id
			+ '" class="competenceTable"> <tr> '
			+ chb
			+ ' <th class="headerRow firstHeader"><a class="compHeader" >'
			+ this.comp.name
			+ ': </a><a class="subComp">' + cl 
			+ '</a></th> <th class="ratingRow">++</th> <th class="halfRatingRow"> </th> <th class="ratingRow">+</th> <th class="halfRatingRow"> </th> <th class="ratingRow">o</th> <th class="halfRatingRow"> </th> <th class="ratingRow">-</th> <th class="halfRatingRow"> </th> <th class="ratingRow">--</th> </tr> </table>';
	$('#' + this.parent).append(table);

}

CompetenceTable.prototype.addHeader = function(check) {

	if (check == undefined)
		check = true;

	var c = this.makeCommaList(this.comp.categories);

	var chb = !check ? '' : '<td class="noBorder"><input id="toggle' + this.id
			+ '" type="checkbox"></td>';

	this.table
			.append('<tr>'
					+ chb
					+ '<td><a class="compHeader" >'
					+ this.comp.name
					+ ': </a><a class="subComp">'
					+ c
					+ '</a></td> <td></td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td></tr>');

};

CompetenceTable.prototype.addCategory = function(cat, index, check) {

	if (check == undefined)
		check = true;

	var catName = cat.name;
	var c = this.makeCommaList(cat.criteria, true);

	var chb = !check ? '' : '<td class="noBorder"><input id="chb_' + index
			+ '" type="checkbox" ';

	// if we go back from the preview to the editor, pre-select the checkboxes
	if (check)
		chb += cat.visible ? ' checked="checked" ></td>' : '></td>';

	var tr = index % 2 == 1 ? '<tr>' : '<tr class="secondRow">';

	this.table
			.append(tr
					+ chb
					+ '<td><a class="subCompHeader">'
					+ catName
					+ ': </a>'
					+ c
					+ '</td> <td></td>  <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> <td> </td> </tr>');

	if (check) {
		var chb = this.table.find('#chb_' + index);
		chb[0].cat = cat;
		chb.change(function() {
			this.cat.visible = this.checked;
		});
	}
};

CompetenceTable.prototype.makeCommaList = function(arr, tooltip) {
	var list = '';
	if (arr.length > 0) {

		if (tooltip == undefined || !tooltip) {

			for ( var i = 0; i < arr.length - 1; i++) {
				list += arr[i].name + ', ';
			}
			list += arr[arr.length - 1].name;

		} else {

			for ( var i = 0; i < arr.length - 1; i++) {		
				list += this.makeToolTip(arr[i]) + ', ';
			}
		
			list += this.makeToolTip( arr[arr.length - 1]);
		}
	}
	return list;
};

CompetenceTable.prototype.makeToolTip = function(arr) {
	var tt = '<ul>';
	for ( var j = 0; j < arr.examples.length; j++) {
		tt += '<li>' + arr.examples[j] + '</li>';
	}
	tt += '</ul>';

	if (arr.examples.length > 0)
		return '<a class="tooltip">' + arr.name + '<div>' + tt
				+ '</div></a>';

	return arr.name;

}

function Competence(name, categories) {
	this.name = name;
	this.categories = categories;
}

function Category(name, criteria) {
	this.name = name;
	this.criteria = criteria;
	this.visible = false;
}

function Criterium(name, examples) {
	this.name = name;
	this.examples = examples;
}

Criterium.prototype.bakeToolTip = function() {
	for ( var i = 0; i < this.examples.length; i++) {

	}
};