var Loader = {

	basePath : 'config/',
	sectionsPath : 'bereiche/',
	sectionsFile : 'bereiche.txt',

	sections : [],

	onLoadingError : function(xhr, status, error) {
		alert('Es ist ein Fehler beim Laden einer Datei aufgetreten! Bitte stellen Sie sicher, dass alle Dateien vorhanden und korrekt formatiert sind.');
	},

	loadConfig : function() {

		var onSuccess = function(data) {

			var lines = Loader.splitTextInput(data);
			for ( var i = 0; i < lines.length; i++) {
				Loader.loadSection(lines[i]);
			}

		};		
		
		Loader.loadViaAjax(Loader.sectionsFile, onSuccess);
	
	},

	loadSection : function(name) {

		var extractSection = function(data) {
			data = Loader.splitTextInput(data);

			var title = '';

			var competences = [];
			var currComp = null;
			var currCategory = null;
			var currCrit = null;

			var fieldTitle = 'Titel';
			var fieldCategory = 'Oberbegriff';
			var fieldCriterium = 'Kriterium';
			var fieldExample = 'Beispiel';
			var fieldCompetence = 'Kompetenz';

			for ( var i = 0; i < data.length; i++) {
				var line = data[i];

				var pos = line.indexOf(':');
				if (pos == -1)
					continue;

				var type = line.substring(0, pos).trim();
				var value = line.substring(pos + 1).trim();

				if (type == fieldTitle) {
					title = value;
				} else if (type == fieldCompetence) {

					currComp = new Competence(value, []);
					competences.push(currComp);

				} else if (type == fieldCategory) {

					if (currComp == null)
						continue;// no parent field

					currCategory = new Category(value, []);
					currComp.categories.push(currCategory);

				} else if (type == fieldCriterium) {

					if (currCategory == null)
						continue;// no parent field

					currCrit = new Criterium(value, []);
					currCategory.criteria.push(currCrit);

				} else if (type == fieldExample) {

					if (currCrit == null)
						continue;// no parent field

					currCrit.examples.push(value);

				}

			}
			Loader.sections.push(new Section(title, competences));
		};
		Loader.loadViaAjax(Loader.sectionsPath + name, extractSection);
	},

	splitTextInput : function(data) {
		var lines = data.split("\n");
		for ( var i = 0; i < lines.length; i++) {
			lines[i] = lines[i].trim();
		}
		return lines;
	},

	loadViaAjax : function(url, onSuccess) {
		$.ajax({
			'url' : Loader.basePath + url,
			'async' : false,
			dataType : 'text'
		}).done(onSuccess).fail(Loader.onLoadingError);
	}

};

function Section(name, competences) {
	this.name = name;
	this.competences = competences;
}
